org.codehaus.plexus.interpolation

## Interface ValueSource

All Known Subinterfaces:
  FeedbackEnabledValueSource, QueryEnabledValueSource

All Known Implementing Classes:
  AbstractDelegatingValueSource, AbstractFunctionValueSourceWrapper, AbstractValueSource, EnvarBasedValueSource, MapBasedValueSource, ObjectBasedValueSource, PrefixedObjectValueSource, PrefixedPropertiesValueSource, PrefixedValueSourceWrapper, PropertiesBasedValueSource, SingleResponseValueSource

    public interface ValueSource

Supplies one strategy for resolving a value for an interpolation expression. ValueSources may be stacked.

Version:
  $Id$

### Method Summary

Methods
`void` `clearFeedback()` Clear the feedback accumulated by a prior interpolation run.
`java.util.List` `getFeedback()` Return the feedback about resolution failures for a particular expression.
`java.lang.Object` `getValue(java.lang.String expression)`

### Method Detail

#### getValue

    java.lang.Object getValue(java.lang.String expression)

Returns:
  the value related to the expression, or null if not found.

#### getFeedback

    java.util.List getFeedback()

Return the feedback about resolution failures for a particular expression.

Returns:
  a combination of String and Throwable instances, where strings related to throwables are listed first.

#### clearFeedback

    void clearFeedback()

Clear the feedback accumulated by a prior interpolation run.